#!/bin/sh

edit_client(){
  id="$1"
  if [ -f "clients/$id" ]; then
    read -r address hourly <"clients/$id"
  fi
  [ "$address" ] || address="address="
  [  "$hourly" ] ||  hourly="hourly="
  printf '
    [form method="POST" action="/update_client"
      [hidden "id" "%s"]
      <textarea name="address" placeholder="address">
%s</textarea>
      [label for=hourly Hourly Rate:]
      [input #hourly type=number name=hourly value="%s"]
      [submit "update" "%s" Update]
    ]' \
    "$(HTML $id)" \
    "$(UNSTRING "${address#address=}" |HTML)" \
    "$(UNSTRING "${hourly#hourly=}" |grep -xE '[0-9]+')" \
    "$(tid "clients/$id")"
}

list_clients(){
  [ -d clients/ ] && for c in clients/*; do
    read -r address hourly <"$c"
    address="$(UNSTRING "${address#address=}")"
    [ "$address" ] || address="(no address)"
    printf '[div .client .address <!--
      -->%s

[label Hourly Rate:] %s€
    [a href="/clients/%s" Edit]]
    ' "$(HTML "$address")" \
      "$(HTML "${hourly#hourly=}")" \
      "$(HTML "${c#clients/}")"
  done
}

update_client(){
  local id="$(POST id |checkid)"
  if [ "$(POST update)" = "$(tid "clients/$id")" ]; then
    mkdir -p clients
    printf 'address=%s	hourly=%s' \
      "$(POST address |STRING)" "$(POST hourly |STRING)" \
      >"clients/$id"

    [ -d .git ] && {
      git add "clients/$id"
      git commit -m 'Update client info for "'"$(POST address |sed 1q)"'"' -- "clients/$id"
    } >/dev/null

    REDIRECT "/clients/"
  else
    error Invalid Data "$id" "$(POST update)"
    REDIRECT "/clients/$1"
  fi
}
