#!/bin/sh

edit_sender(){
  local id="$1" address iban bic
  [ -f "senders/$id" ] \
  && read -r address iban bic <"senders/$id"

  iban="$(UNSTRING "${iban#iban=}")"
   bic="$(UNSTRING "${bic#bic=}")"

  [ "${address#address=}" ] \
  && address="$(UNSTRING "${address#address=}")" \
  || address="Name
Street
City

Phone:
000 000000

Tax no.
xxx / 000 / ###
"
  printf '
    [form method="POST" action="/update_sender"
      [hidden "id" "%s"]
      <textarea name="address" placeholder="address">%s</textarea>
      [label IBAN:][input name=iban value="%s" placeholder=IBAN]
      [label BIC:][input name=bic value="%s" placeholder=BIC]
      [submit "update" "%s" Update]
    ]' \
    "$(HTML $id)" "$(HTML "${address}")" \
    "$(HTML "${iban}")" "$(HTML "${bic}")" \
    "$(tid "senders/$id")"
}

list_senders(){
  [ -d senders/ ] && for s in senders/*; do
    read -r address iban bic <"$s"

    [ "${address#address=}" ] \
    && address="$(UNSTRING "${address#address=}")" \
    || address="(no address)"

    printf '[div .sender .address <!--
      -->%s[a href="/senders/%s" Edit]]
    ' "$(HTML "$address")" "$(HTML "${s#senders/}")"
  done
}

update_sender(){
  id="$(POST id |checkid)"
  if [ "$(POST update)" = "$(tid "senders/$id")" ]; then
    mkdir -p senders
    printf 'address=%s	iban=%s	bic=%s\n' \
    $(POST address |STRING) $(POST iban |STRING) \
    $(POST bic |STRING) >"senders/$id"

    [ -d .git ] && {
      git add "senders/$id"
      git commit -m 'Update sender info for "'"$(POST address |sed 1q)"'"' -- "senders/$id"
    } >/dev/null

    REDIRECT "/senders/"
  else
    REDIRECT "/senders/$id"
  fi
}
